package it.unibs.fp.patenteelibbrettopregoh;

import it.kibo.fp.lib.InputData;

import java.util.ArrayList;

public class PatenteELibbrettoPregohMain {
    public static void main(String[] args) {
        System.out.println("PatenteELibbrettoPregoh!");
        Formato formato = getFormato();
        System.out.println();
        GameData gameData = new GameData(formato);

        while (gameData.getStatoGioco() == StatoGioco.IN_CORSO) {
            int personeChePassano = ((int)(Math.random() * 5) + 3);
            System.out.println("Il giorno " + gameData.getData() + " passeranno " + personeChePassano + " persone");
            ArrayList<PersonaControllata> personeControllate = new ArrayList<>();
            for (int i = 0; i < personeChePassano; i++) {
                if (gameData.getStatoGioco() == StatoGioco.IN_CORSO) {
                    Persona personaDaControllare = gameData.getPersonaDaControlare();
                    boolean esito = controllaPersona(personaDaControllare, gameData.getComuni(), gameData);
                    boolean accettata = InputData.readYesOrNo("Si presenta\n" + personaDaControllare + "\nC.F. calcolato: " + personaDaControllare.calcolaCodiceFiscale(gameData.getComuni()) + "\nAccettare");
                    if (accettata) {
                        if (esito){
                            System.out.println("La persona aveva i dati corretti");
                            PersonaControllata personaControllata = new PersonaControllata(personaDaControllare, true, TipoPersonaControllata.PERSONA_NORMALE);
                            personeControllate.add(personaControllata);
                        } else {
                            System.out.println("La persona aveva i dati errati");
                            PersonaControllata personaControllata = new PersonaControllata(personaDaControllare, true, TipoPersonaControllata.PERSONA_NORMALE);
                            personeControllate.add(personaControllata);
                            if (Math.random() < 0.5){
                                System.out.println("Sei stato fortunato, non hai presso la multa");
                            } else {
                                System.out.println("Hai preso una multa da 300§");
                                gameData.pagaMulta(300);
                            }
                        }
                    } else {
                        if (esito) {
                            System.out.println("La persona aveva i dati corretti ... come sei salato");
                            PersonaControllata personaControllata = new PersonaControllata(personaDaControllare, false, TipoPersonaControllata.PERSONA_NORMALE);
                            personeControllate.add(personaControllata);
                            if (Math.random() < 0.5){
                                System.out.println("Sei stato fortunato, non hai presso la multa");
                            } else {
                                System.out.println("Hai preso una multa da 150§");
                                gameData.pagaMulta(150);
                            }
                        } else {
                            System.out.println("La persona aveva i dati errati");
                            PersonaControllata personaControllata;

                            if (Math.random() < 0.4){
                                int mazzetta = ((int)((Math.random() * 251))) + 250;
                                System.out.println(personaDaControllare.getNome() + " " + personaDaControllare.getCognome() + " prova a corromperti con " + mazzetta + "§");
                                boolean accettataMazzetta = InputData.readYesOrNo("Accettare la mazzetta");
                                if (accettataMazzetta){
                                    gameData.addSaldo(mazzetta);
                                    if (Math.random() < 0.7){
                                        System.out.println("Hai accettato la mazzetta, ti è andata bene ... era un rivoluzionario");
                                        gameData.incrementaRivoluzionariAccettati();
                                        personaControllata = new PersonaControllata(personaDaControllare, true, TipoPersonaControllata.RIVOLUZIONARIO);
                                    } else {
                                        System.out.println("Hai accettato la mazzetta ... era un poliziotto");
                                        gameData.incrementaMazzetteAccettatePolizia();
                                        gameData.pagaMulta(gameData.getSaldo() * 0.6);
                                        personaControllata = new PersonaControllata(personaDaControllare, true, TipoPersonaControllata.POLIZIOTTO);
                                    }
                                } else {
                                    personaControllata = new PersonaControllata(personaDaControllare, false, TipoPersonaControllata.PERSONA_NORMALE);
                                }
                            } else {
                                personaControllata = new PersonaControllata(personaDaControllare, false, TipoPersonaControllata.PERSONA_NORMALE);
                            }
                            personeControllate.add(personaControllata);
                        }
                    }
                }
            }

            gameData.incrementaGiorno(personeControllate.size());
        }

        switch (gameData.getStatoGioco()){
            case ARRESTATO -> System.out.println("Sei stato arrestato");
            case GIUSTIZIATO -> System.out.println("Sei stato giustiziato");
            case RIVOLUZIONE -> System.out.println("Hai vinto la rivoluzione");
            case DODICESIMO_GIORNO -> System.out.println("Hai vinto, sei sopravvissuto 12 giorni");
            case NON_ABBASTANZA_SOLDI -> System.out.println("Non hai abbastanza soldi");
            default -> System.out.println("Hai perso");
        }

    }

    private static boolean controllaPersona(Persona persona, Comuni comuni, GameData gameData) {
        return persona.isCodiceFiscaleValido(comuni) && persona.isDocumentoValido(gameData.getData());
    }

    private static Formato getFormato() {
        Formato formato = null;

        int sceltaFormato = InputData.readIntegerBetween("Inserisci il formato (0: JSON, 1: XML): ", 0, 1);
        if (sceltaFormato == 0) {
            System.out.println("Hai scelto il formato JSON");
            formato = Formato.JSON;
        } else {
            System.out.println("Hai scelto il formato XML");
            formato = Formato.XML;
        }
        return formato;
    }
}
